/***************************************************************************

 Author        : CAST 

 Date          : March 10th, 2011

 File          : ADF4118_IO.c

 Hardware      : ADuC7026 and ADF4118
	
***************************************************************************/
#include <ADuC7026.h>
#include "ADuC7026Driver.h"
#include "ADF4118_IO.h"

unsigned long int ADF4118Registers[4];

void config (void)
{
	ADF4118Registers[0]=0;
	ADF4118Registers[1]=0;
	ADF4118Registers[2]=0;
	ADF4118Registers[3]=0;

	ADF4118Registers[Reference_Counter_LATCH]=(Reference_Counter_LATCH|TEST_MODE_BITS|BIT_14_REFERENCE_COUNTER);
	ADF4118Registers[AB_COUNTER_LATCH]=(AB_COUNTER_LATCH|BIT_13_B_COUNTER|BIT_5_A_COUNTER);
	ADF4118Registers[FUNCTION_LATCH]=(FUNCTION_LATCH|PHASE_DETECTOR_POLARITY);
	ADF4118Registers[INITIALIZATION_LATCH]=(INITIALIZATION_LATCH|PHASE_DETECTOR_POLARITY);

}

void delay (int length)
{
	while (length >0)
    	length--;
}

//---------------------------------
//void WriteToADF4118(unsigned long int *buff , char Adress)
//---------------------------------

void WriteToADF4118(unsigned long int *buff , char Adress)
{
    unsigned	char      i;
	unsigned	long int  temp ;
	
	SET_DATA_OUT();	
	delay(1);
	CLR_CLK();
	CLR_LE();
    temp =*(buff+Adress);
	for(i=0; i<21; i++)
	{
			if(temp & 0x100000)
			{
				SET_DATA();	  //Send one to SDO pin
			}
			else
			{
				CLR_DATA();	  //Send zero to SDO pin
			}
			delay(1);
			SET_CLK();
			temp <<= 1;	//Rotate data
			CLR_CLK();		
	}
	delay(1);
	SET_LE();
	delay(1);
	CLR_LE();
}
