/***************************************************************************

 Author        :  CAST

 Date          : March 11th, 2011

 File          : ADF4118_IO.h

 Hardware      : ADuC7026 and ADF4118
	
***************************************************************************/


#define  Reference_Counter_LATCH   0
#define  AB_COUNTER_LATCH          1
#define  FUNCTION_LATCH            2
#define  INITIALIZATION_LATCH      3

/***************************************************************************/
/*********       define Reference_Counter_LATCH     ************************/
#define  R_COUNTER		 	     96

#define  LOCK_DETECT_PRECISION		   (0x1<<20)
#define  TEST_MODE_BITS				   (0x0<<16)
#define  BIT_14_REFERENCE_COUNTER	   (R_COUNTER <<2)

/***************************************************************************/
/*********       define AB_COUNTER_LATCH     *******************************/

#define  B_COUNTER			  306
#define  A_COUNTER			  8

#define  CP_GAIN					   (0x1<<20)
#define  BIT_13_B_COUNTER			   (B_COUNTER<<7)
#define  BIT_5_A_COUNTER	    	   (A_COUNTER<<2)

/***************************************************************************/
/*********       define FUNCTION_LATCH          ****************************/
#define  TIMER_COUNTER_CONTROL		   7


#define  NORMAL_OPERATION			   ((0x0<<19)|(0x0<<3))
#define  ASYNCHRONOUS_POWER_DOWN	   ((0x0<<19)|(0x1<<3))
#define  SYNCHRONOUS_POWER_DOWN		   ((0x1<<19)|(0x1<<3))
#define  BIT_4_TIMER_COUNTER_CONTROL   (TIMER_COUNTER_CONTROL<<12)
#define  FASTLOCK_DISABLED			   ((0x0<<11)|(0x0<<9))
#define  FASTLOCK_MODE_1			   ((0x1<<11)|(0x0<<9))
#define  FASTLOCK_MODE_2			   ((0x1<<11)|(0x1<<9))
#define  CHARGE_PUMP_OUTPUT			   (0x1<<8)
#define  PHASE_DETECTOR_POLARITY	   (0x1<<7)

#define  THREE_STATE_OUTPUT			   (0x0<<4)
#define  DIGITAL_LOCK_DETECT		   (0x1<<4)
#define  N_DIVIDER_OUTPUT			   (0x2<<4)
#define  AVDD						   (0x3<<4)
#define  R_DIVIDER_OUTPUT			   (0x4<<4)
#define  ANALOG_LOCK_DETECT			   (0x5<<4)
#define  SERIAL_DATA_OUTPUT			   (0x6<<4)
#define  DGND						   (0x7<<4)

#define  COUNTER_RESET				   (0x1<<2)

/***************************************************************************/
/*********       define INITIALIZATION_LATCH            ********************/

extern  unsigned long int ADF4118Registers[4];

void WriteToADF4118(unsigned long int *buff , char Adress);
void config(void);
void delay (int length);

